-- This is a rather fast Client Locale Creation.
-- Instead of loading a single file or a bunch of files that each make a check for the locale type
-- I instead set this up so it completely generates the table here and exports it to the Core Lua
-- This is one approach I have not seen performed yet.

-- Its simple, the CGC_SetupLocale is called with GetLocale() as a param, that retreives the locale from the system
-- Which is then compared to and returns the completed table to the awaiting variable, however I also generate the meta table here too.

function CGC_SetupLocale(Locale)
   local T = setmetatable({}, {__index=function(self, key) return key end});   

   if Locale == "frFR" then
      -- General UI
      T["Cross Guild Chat"] = "Cross Guild Chat"
      T["Connected"] = "Connecté"
      T["Disconnected"] = "Deconnecté"
      T["Left Click"] = "Bouton gauche"
      T["Right Click"] = "Bouton droit"
      T["Hold Left Click"] = "Peser bouton gauche"
      T["Cross Guild Roster"] = "Liste d'utilisateurs Cross Guild"
      T["Control Panel"] = "Configuration"
      T["Move Button"] = "Déplacer bouton"

      -- Popup Dialogs ##%s is either a name or a guild##
      T["Enter the name for the Player you wish to send this Guild Link to."] = "Entrer le nom du joueur à qui vous voulez envoyer ce Lien de Guilde."
      T["Are you sure you wish to send your Guild Link to %s?"] = "Êtes-vous certain de vouloir envoyer votre Lien de Guilde à %s?"
      T["%s has sent you a Guild Link."] = "%s vous a envoyé un Lien de Guilde."
      T["%s, would you like to Create a New Guild Link, or use an existing Guild Link."] = "%s, voulez-vous créer un nouveau Lien de Guilde ou utiliser un Lien de Guilde existant?"
      T["Are you sure you wish to clear all Cross Guild Chat Settings?"] = "Êtes-vous certain de vouloir effacer tous les paramètres de Cross Guild Chat?"
      T["Are you sure you wish to clear all Player Information Cache?"] = "Êtes-vous certain de vouloir effacer la mémoire cache d'information des joueurs?"
      T["Are you sure you wish to clear your Whitelist?"] = "Êtes-vous certain de vouloir effacer votre liste blanche?"
      T["%s already has an existing Guild Link, are you sure you wish to Create a New Link?"] = "%s a déjà un Lien de Guilde, êtes-vous certain de vouloir en créer un nouveau?"

      T["Use Existing"] = "Utiliser existant"
      T["Create New"] = "Créer nouveau"
      T["Accept"] = "Accepter"
      T["Decline"] = "Refuser"
      T["Send"] = "Envoyer"
      T["Quit"] = "Quitter"
      T["Yes"] = "Oui"
      T["No"] = "Non"

      -- GUI
      T["Connect"] = "Connexion"
      T["Disconnect"] = "Déconnexion"
      T["No Active Guild Link"] = "Aucun Lien actif"

      T["Handling Guild Link"] = "Traitement du Lien"
      T["Connecting to Guild Link"] = "Connexion au Lien"
      T["Starting Guild Link Session"] = "Lancement de session du Lien"
      T["Guild Link Data Missing"] = "Données manquantes au Lien"
      T["Guild Link Sync Error"] = "Erreur de synchronisation avec le Lien"
      T["Guild Link Connected"] = "Connecté au Lien"
      T["Checking Existing Links"] = "Vérification du Lien"
      T["Guild Link Length Error"] = "Erreur de durée du Lien"
      T["Guild Link Not Found"] = "Aucun Lien de Guilde retrouvé"
      T["No Guild Link Found"] = "Aucun Lien de Guilde retrouvé"

      T["Guild Link Missing User List"] = "Liste d'utilisateurs manquants"
      T["Guild Link Members Online: "] = "Utilisateurs en ligne: "
      T["Sort: "] = "Trier: "
      T["Sort:"] = "Trier:"
      
      -- Stats
      T["Current Session"] = "Session actuelle"
      T["Session Data"] = "Données de session"
      T["Link Start: "] = "Lié depuis: "
      T["Linked Users: "] = "Utilisateurs liés: "
      T["Data Out: "] = "Données sort: "
      T["Data In: "] = "Données entr: "
      T["Lines Out: "] = "Lignes sort: "
      T["Lines In: "] = "Lignes entr: "
      T["STATUS"] = "STATUT"

      -- GUI Buttons/Checkboxes
      T["Whitelist: Enabled"] = "Liste bl: Activée"
      T["Whitelist: Disabled"] = "Liste bl: Désactivée"
      T["Whitelist: No Access"] = "Liste bl: Aucun accès"
      T["Show Achievements"] = "Montrer hauts faits"
      T["Show Minimap Button"] = "Bouton sur la mini-carte"
      T["Add"] = "Ajout"
      T["Clear Whitelist"] = "Purger liste blanche"
      T["Clear Settings"] = "Purger les configurations"
      T["Purge Player Cache"] = "Purger cache des joueurs"
      T["Generate Guild Link"] = "Générer Lien"
      T["Send Guild Link"] = "Envoyer Lien"
      T["Guild Link Check"] = "Vérifier Lien"
      T["CLOSE"] = "FERMER"
      T["Send Notice"] = "Envoyer avis"

      -- Column Tabs
      T["Whitelist"] = "Liste blanche"
      T["Cls"] = "Cls" --or Class if short enough
      T["Rce"] = "Rce" --or Race if Short enough
      T["Name"] = "Nom"
      T["Guild"] = "Guilde"

      -- CLI Messages
      T["Guild Link Received from"] = "Lien de Guilde reçu de"
      T["Cataclysm Features Enabled"] = "Fonctionnalités Cataclysme activées"
      T["Guild Link Sent to"] = "Lien de Guilde envoyé à" 
      
   elseif Locale == "deDE" then
      -- PASS 1, INCOMPLETE
      -- General UI
      T["Cross Guild Chat"] = "Cross Guild Chat"
      T["Connected"] = "Verbunden"
      T["Disconnected"] = "Verbindung Getrennt"
      T["Left Click"] = "Linksclick"
      T["Right Click"] = "Rechtsclick"
      T["Hold Left Click"] = "Linke Maustaste gedrückt halten"
      T["Cross Guild Roster"] = "Cross Guild Liste"
      T["Control Panel"] = "Einstellungen"
      T["Move Button"] = "Button Verschieben"

      -- Popup Dialogs ##%s is either a name or a guild##
      T["Enter the name for the Player you wish to send this Guild Link to."] = "Geben Sie den Namen des Spielers ein, dem sie diesen Gildenlink schicken wollen."
      T["Are you sure you wish to send your Guild Link to %s?"] = "Sind Sie sich sicher, dass Sie ihren Gildenlink an %s schicken wollen?"
      T["%s has sent you a Guild Link."] = "%s hat Ihnen einen Gildenlink geschickt."
      T["%s, would you like to Create a New Guild Link, or use an existing Guild Link."] = "%s, wollen Sie einen neuen Gildenlink erstellen oder einen existierenden verwenden?"
      T["Are you sure you wish to clear all Cross Guild Chat Settings?"] = "Sind Sie sich sicher dass sie alle Cross Guild Chat Einstellungen löschen wollen?"
      T["Are you sure you wish to clear all Player Information Cache?"] = "Sind Sie sich sicher dass Sie den Spielerinformations-Cache löschen wollen?"
      T["Are you sure you wish to clear your Whitelist?"] = "Sind Sie sich sicher dass Sie ihre Whitelist löschen wollen?"
      T["%s already has an existing Guild Link, are you sure you wish to Create a New Link?"] = "%s hat bereits einen bestehenden Gildenlink, sind Sie sich sicher dass Sie einen neuen Gildenlink erstellen wollen?"

      T["Use Existing"] = "Existierenden Verwenden"
      T["Create New"] = "Neu Erstellen"
      T["Accept"] = "Annehmen"
      T["Decline"] = "Ablehnen"
      T["Send"] = "Schicken"
      T["Quit"] = "Schließen"
      T["Yes"] = "Ja"
      T["No"] = "Nein"

      -- GUI
      T["Connect"] = "Verbinden"
      T["Disconnect"] = "Verbindung Trennen"
      T["No Active Guild Link"] = "Kein Aktiver Gildenlink"

      T["Handling Guild Link"] = "Bearbeite Gildenlink"
      T["Connecting to Guild Link"] = "Verbinde zu Gildenlink"
      T["Starting Guild Link Session"] = "Starte Gildenlink-Sitzung"
      T["Guild Link Data Missing"] = "Gildenlink-Daten Fehlen"
      T["Guild Link Sync Error"] = "Gildenlink Synchronisationsfehler"
      T["Guild Link Connected"] = "Gildenlink Verbunden"
      T["Checking Existing Links"] = "Prüfe Bestehende Links"
      T["Guild Link Length Error"] = "Fehler Bei Gildenlink-Länge"
      T["Guild Link Not Found"] = "Gildenlink Nicht Gefunden"
      T["No Guild Link Found"] = "Kein Gildenlink Gefunden"

      T["Guild Link Missing User List"] = "Gildenlink-Benutzerliste Fehlt"
      T["Guild Link Members Online: "] = "Gildenlink Mitglieder Online: "
      T["Sort: "] = "Sortieren: "
      T["Sort:"] = "Sortieren:"
      
      -- Stats
      T["Current Session"] = "Diese Sitzung"
      T["Session Data"] = "Sitzungsdaten"
      T["Link Start: "] = "Verbindungsbeginn: "
      T["Linked Users: "] = "Verbundene Benutzer: "
      T["Data Out: "] = "Ausgehende Daten: "
      T["Data In: "] = "Eingehende Daten: "
      T["Lines Out: "] = "Ausgehende Zeilen: "
      T["Lines In: "] = "Eingehende Zeilen: "
      T["STATUS"] = "STATUS"

      -- GUI Buttons/Checkboxes
      T["Whitelist: Enabled"] = "Whitelist: Aktiv"
      T["Whitelist: Disabled"] = "Whitelist: Inaktiv"
      T["Whitelist: No Access"] = "Whitelist: Kein Zugriff"
      T["Show Achievements"] = "Erfolge Anzeigen"
      T["Show Minimap Button"] = "Minimap Button Anzeigen"
      T["Add"] = "Hinzufügen"
      T["Clear Whitelist"] = "Whitelist Löschen"
      T["Clear Settings"] = "Einstellungen Löschen"
      T["Purge Player Cache"] = "Spieler-Cache Löschen"
      T["Generate Guild Link"] = "Gildenlink Erstellen"
      T["Send Guild Link"] = "Gildenlink Verschicken"
      T["Guild Link Check"] = "Gildenlink Prüfen"
      T["CLOSE"] = "SCHLIEßEN"
      T["Send Notice"] = "Nachricht Schicken"

      -- Column Tabs
      T["Whitelist"] = "Whitelist"
      T["Cls"] = "Kl." --or Klasse if short enough
      T["Rce"] = "R." --or Rasse if Short enough
      T["Name"] = "Name"
      T["Guild"] = "Gilde"

      -- CLI Messages
      T["Guild Link Received from"] = "Gildenlink Empfangen Von"
      T["Cataclysm Features Enabled"] = "Cataclysm Features Aktiviert"
      T["Guild Link Sent to"] = "Gildenlink Geschickt An"
   
   elseif Locale == "enGB" then
   
   elseif Locale == "enUS" then -- Not required for enUS accounts, but exists for debug reasons.
      -- General UI
      T["Cross Guild Chat"] = "Cross Guild Chat"
      T["Connected"] = "Connected"
      T["Disconnected"] = "Disconnected"
      T["Left Click"] = "Left Click"
      T["Right Click"] = "Right Click"
      T["Hold Left Click"] = "Hold Left Click"
      T["Cross Guild Roster"] = "Cross Guild Roster"
      T["Control Panel"] = "Control Panel"
      T["Move Button"] = "Move Button"
            
      -- Popup Dialogs
      T["Enter the name for the Player you wish to send this Guild Link to."] = "Enter the name for the Player you wish to send this Guild Link to."
      T["Are you sure you wish to send your Guild Link to %s?"] = "Are you sure you wish to send your Guild Link to %s?"
      T["%s has sent you a Guild Link."] = "%s has sent you a Guild Link."
      T["%s, would you like to Create a New Guild Link, or use an existing Guild Link."] = "%s, would you like to Create a New Guild Link, or use an existing Guild Link."
      T["Are you sure you wish to clear all Cross Guild Chat Settings?"] = "Are you sure you wish to clear all Cross Guild Chat Settings?"
      T["Are you sure you wish to clear all Player Information Cache?"] = "Are you sure you wish to clear all Player Information Cache?"
      T["Are you sure you wish to clear your Whitelist?"] = "Are you sure you wish to clear your Whitelist?"
      T["%s already has an existing Guild Link, are you sure you wish to Create a New Link?"] = "%s already has an existing Guild Link, are you sure you wish to Create a New Link?"
      
      T["Use Existing"] = "Use Existing"
      T["Create New"] = "Create New"
      T["Accept"] = "Accept"
      T["Decline"] = "Decline"
      T["Send"] = "Send"
      T["Quit"] = "Quit"
      T["Yes"] = "Yes"
      T["No"] = "No"
      
      -- GUI
      T["Connect"] = "Connect"
      T["Disconnect"] = "Disconnect"
      T["No Active Guild Link"] = "No Active Guild Link"
      
      T["Handling Guild Link"] = "Handling Guild Link"
      T["Connecting to Guild Link"] = "Connecting to Guild Link"
      T["Starting Guild Link Session"] = "Starting Guild Link Session"
      T["Guild Link Data Missing"] = "Guild Link Data Missing"
      T["Guild Link Sync Error"] = "Guild Link Sync Error"
      T["Guild Link Connected"] = "Guild Link Connected"
      T["Checking Existing Links"] = "Checking Existing Links"
      T["Guild Link Length Error"] = "Guild Link Length Error"
      T["Guild Link Not Found"] = "Guild Link Not Found"
      T["No Guild Link Found"] = "No Guild Link Found"
      
      T["Guild Link Missing User List"] = "Guild Link Missing User List"
      T["Guild Link Members Online: "] = "Guild Link Members Online: "
      T["Sort: "] = "Sort: "
      T["Sort:"] = "Sort:"
            
      -- Stats
      T["Current Session"] = "Current Session"
      T["Session Data"] = "Session Data"
      T["Link Start: "] = "Link Start: "
      T["Linked Users: "] = "Linked Users: "
      T["Data Out: "] = "Data Out: "
      T["Data In: "] = "Data In: "
      T["Lines Out: "] = "Lines Out: "
      T["Lines In: "] = "Lines In: "
      T["STATUS"] = "STATUS"
      
      -- GUI Buttons/Checkboxes
      T["Whitelist: Enabled"] = "Whitelist: Enabled"
      T["Whitelist: Disabled"] = "Whitelist: Disabled"
      T["Whitelist: No Access"] = "Whitelist: No Access"
      T["Show Achievements"] = "Show Achievements"
      T["Show Minimap Button"] = "Show Minimap Button"
      T["Add"] = "Add"
      T["Clear Whitelist"] = "Clear Whitelist"
      T["Clear Settings"] = "Clear Settings"
      T["Purge Player Cache"] = "Purge Player Cache"
      T["Generate Guild Link"] = "Generate Guild Link"
      T["Send Guild Link"] = "Send Guild Link"
      T["Guild Link Check"] = "Guild Link Check"
      T["CLOSE"] = "CLOSE"
      T["Send Notice"] = "Send Notice"
      
      -- Column Tabs
      T["Whitelist"] = "Whitelist"
      T["Cls"] = "Cls" --or Class if short enough
      T["Rce"] = "Rce" --or Race if Short enough
      T["Name"] = "Name"
      T["Guild"] = "Guild"
     
      -- CLI Messages
      T["Guild Link Received from"] = "Guild Link Received from"
      T["Cataclysm Features Enabled"] = "Cataclysm Features Enabled"
      T["Guild Link Sent to"] = "Guild Link Sent to"
   
   elseif Locale == "koKR" then
      -- General UI
      T["Cross Guild Chat"] = "크로스 길드챗 크로스 길드챗"
      T["Connected"] = "연결됨" 
      T["Disconnected"] = "연결 안됨" 
      T["Left Click"] = "왼클릭" 
      T["Right Click"] = "오른클릭" 
      T["Hold Left Click"] = "오른클릭 누르고 있기" 
      T["Cross Guild Roster"] = "크로스 길드챗 명부"
      T["Control Panel"] = "제어판" 
      T["Move Button"] = "움직이기 버튼 움직이기 버튼"

      -- Popup Dialogs ##%s is either a name or a guild##
      T["Enter the name for the Player you wish to send this Guild Link to."] = "길드 링크를 받는 사용자의 이름 입력하세요"
      T["Are you sure you wish to send your Guild Link to %s?"] = "%s 에게 길드 링크를 보낼것입니까?"
      T["%s has sent you a Guild Link."] = "%s 에게서 길드 링크를 받았습니다." 
      T["%s, would you like to Create a New Guild Link, or use an existing Guild Link."] = "%s, 새로운 길드링크를 사용할것입니까 아니면 벌써 있는 링크를 사용할것입니까" 
      T["Are you sure you wish to clear all Cross Guild Chat Settings?"] = "세팅을 다 지울것입니까?"
      T["Are you sure you wish to clear all Player Information Cache?"] = "모든 사용자 정보를 지울것입니까?"
      T["Are you sure you wish to clear your Whitelist?"] = "화이트 리스트의 설정을 모두 지울것입니까?"
      T["%s already has an existing Guild Link, are you sure you wish to Create a New Link?"] = "%s는 길드링크가 벌써 있습니다. 새로운 링크를 만들것입니까?"

      T["Use Existing"] = "현재 있는링크를 쓰기"
      T["Create New"] = "새로운 링크를 만들기"
      T["Accept"] = "수락"
      T["Decline"] = "거절"
      T["Send"] = "보내기"
      T["Quit"] = "끝내기 끝내기"
      T["Yes"] = "예"
      T["No"] = "아니오"

      -- GUI
      T["Connect"] = "링크를 연결하기"
      T["Disconnect"] = "링크를 끊다"
      T["No Active Guild Link"] = "길드 링크 없음"

      T["Handling Guild Link"] = "길드 링크를 처리하기..."
      T["Connecting to Guild Link"] = "길드 링크를 연결하기..."
      T["Starting Guild Link Session"] = "길드 링크 의 세션을 시작하기..."
      T["Guild Link Data Missing"] = "길드 링크 데이터가 없습니다."
      T["Guild Link Sync Error"] = "길드 링크 실패"
      T["Guild Link Connected"] = "길드 링크 성공"
      T["Checking Existing Links"] = "현재 있는링크 조사하기..."
      T["Guild Link Length Error"] = "길드 링크 길이 실수"
      T["Guild Link Not Found"] = "길드 링크를 찾지 못했습니다"
      T["No Guild Link Found"] = "길드 링크를 찾지 못했습니다"

      T["Guild Link Missing User List"] = "길드 링크가 없는 유저들"
      T["Guild Link Members Online: "] = "길드 링크 사용자 온라인: "
      T["Sort: "] = "분류: "
      T["Sort:"] = "분류:"
      
      -- Stats
      T["Current Session"] = "현재 있는 세션"
      T["Session Data"] = "세션의 데이터"
      T["Link Start: "] = "링크 시작 시간: "
      T["Linked Users: "] = "연결된 사용자: "
      T["Data Out: "] = "나가는 데이터: "
      T["Data In: "] = "들어오는 데이터: "
      T["Lines Out: "] = "나가는 라인: "
      T["Lines In: "] = "들어오는 라인: "
      T["STATUS"] = "상태"

      -- GUI Buttons/Checkboxes
      T["Whitelist: Enabled"] = "화이트 리스트: 활성"
      T["Whitelist: Disabled"] = "화이트 리스트: 비활성"
      T["Whitelist: No Access"] = "화이트 리스트: 접근 불가"
      T["Show Achievements"] = "업적 알림를 보고하기"
      T["Show Minimap Button"] = "미니맵 단추를 보여주기"
      T["Add"] = "더하기"
      T["Clear Whitelist"] = "화이트 리스트 제거하기"
      T["Clear Settings"] = "설정 지우기"
      T["Purge Player Cache"] = "사용자 데이터를 삭제하기"
      T["Generate Guild Link"] = "길드 링크를 만들기"
      T["Send Guild Link"] = "길드 링크 보내기"
      T["Guild Link Check"] = "길드 링크 조사하기"
      T["CLOSE"] = "닫기"
      T["Send Notice"] = "없어진 사용자에게 경고를 보내기"

      -- Column Tabs
      T["Whitelist"] = "화이트 리스트"
      T["Cls"] = "클래스" --or Class if short enough
      T["Rce"] = "종족" --or Race if Short enough
      T["Name"] = "이름"
      T["Guild"] = "길드"


      -- CLI Messages
      T["Guild Link Received from"] = "길드 링크 접수헸다! 송신자:"
      T["Cataclysm Features Enabled"] = "대격변 특징을 활성화"
      T["Guild Link Sent to"] = "길드 링크 보낸다. 수납자:"
      
   elseif Locale == "zhCN" then
   
   elseif Locale == "zhTW" then
   
   elseif Locale == "ruRU" then
   
   elseif Locale == "esES" then
   
   elseif Locale == "esMX" then
      
   end

   return T
end