-- SAM Throttle Library
-- Simple Method
-- Designed and Written by Lemon King

local LKThrottleHooks = {}
local debug = false

function LKThrottleShowDebug(line)
   if debug == false then return end
   DEFAULT_CHAT_FRAME:AddMessage(line);
end

function LKThrottleRegister(addon, batch, max, time, idlemax)
   if ( LKThrottleHooks[addon] ) then return end
   local frame
   LKThrottleHooks[addon] = {}
   LKThrottleHooks[addon]["Batch"] = batch
   LKThrottleHooks[addon]["Max"] = max
   LKThrottleHooks[addon]["BatchTime"] = (time / batch)
   LKThrottleHooks[addon]["ElapsedTime"] = 0
   LKThrottleHooks[addon]["IdleCount"] = 0
   LKThrottleHooks[addon]["IdleMax"] = idlemax
   if not ( _G["LKTHROTTLEHOOK_"..addon] ) then
      frame = CreateFrame("Frame", "LKTHROTTLEHOOK_"..addon);  
   end
   LKThrottleHooks[addon]["Frame"] = frame
   frame.elapsed = 0
   frame.name = addon
   LKThrottleHooks[addon]["Cache"] = {}  
   LKThrottleShowDebug("LK THROTTLE: "..addon.." IS REGISTERED!"); 
end


function LKThrottleAdd(addon, prefix, text, type, target)
   if ( LKThrottleHooks[addon] ) then
      if #LKThrottleHooks[addon]["Cache"] == 0 then 
         LKThrottleHooks[addon]["Frame"]:SetScript("OnUpdate", LKThrottle_OnUpdate)
      end
      if #LKThrottleHooks[addon]["Cache"] < LKThrottleHooks[addon]["Max"] then
         local pos
         if not ( LKThrottleExists(target, addon) ) then
            tinsert(LKThrottleHooks[addon]["Cache"], { prefix, text, type, target })
         end
      end
   else
      LKThrottleShowDebug("NOTICE: LK THROTTLE IS NOT SETUP!");   
   end

end

function LKThrottle_OnUpdate(self, elapsed)
      local addon = self.name
      if self.elapsed <= LKThrottleHooks[addon]["BatchTime"] then 
        self.elapsed = self.elapsed + elapsed;
      elseif  self.elapsed >= LKThrottleHooks[addon]["BatchTime"] then
        if #LKThrottleHooks[addon]["Cache"] >= 1 then
            SendAddonMessage(unpack(LKThrottleHooks[addon]["Cache"][#LKThrottleHooks[addon]["Cache"]]))
            table.remove(LKThrottleHooks[addon]["Cache"], #LKThrottleHooks[addon]["Cache"])
            LKThrottleHooks[addon]["IdleCount"] = 0;
            self.elapsed = 0;     
        else
            LKThrottleHooks[addon]["IdleCount"] = LKThrottleHooks[addon]["IdleCount"] + 1
            self.elapsed = 0
        end
        if LKThrottleHooks[addon]["IdleCount"] >= LKThrottleHooks[addon]["IdleMax"] then
           self:SetScript("OnUpdate",nil) -- Shutdown OnUpdate
           LKThrottleHooks[addon]["IdleCount"] = 0
           LKThrottleShowDebug("NOTICE: LK THROTTLE IS DISABLED!");      
        end
      end
end


function LKThrottleGetAddon(addon)
   if ( LKThrottleHooks[addon] ) then
      return _G["LKTHROTTLEHOOK_"..addon]
   else
      return nil
   end
end

function LKThrottleExists(name, addon)
    for i,v in pairs(LKThrottleHooks[addon]["Cache"]) do
    	if ( LKThrottleHooks[addon]["Cache"][i] ) then
        	if name == LKThrottleHooks[addon]["Cache"][i][4] then
            	return true
         end
      end
    end
    return nil;
end